%values from data (weighted by working age population)
n=2.99;
h=5;
c=1258.816; %hh consumption per worker
y0=1508.905; %output per worker
y1=2959.06;
N0=2.02;
N1=3.52;
mincer=0.11;
taug=0.045;

rho=0.33;
tau1=0.003;
hbar=1;
gA=1.56;

tauh=tau1+(taug/(n*h));

u0=[0.02, 2.7, 0.11];
u = fsolve(@(u) calibration(u, tauh, c, n, h, y0, y1, N0, N1, rho, gA),u0); 

tau0=u(1);
gH=u(2);
alpha=u(3);

z_lower=(gH-1)/h;
z_upper=gH/h;

z_vec=linspace(z_lower+0.001, z_upper-0.001, 9);
theta_vec=zeros(1, 9);
H0_vec=zeros(1, 9);

for i=1:9
    z=z_vec(1,i);
    x0=[0.02, 2.7];
    x = fsolve(@(x) calibration2(x, tauh, c, n, h, y0, gH, z, hbar),x0); 

    theta_vec(1,i)=x(1);
    H0_vec(1,i)=x(2);
end;

z_ideal=mincer*gH/(1-rho);
if (z_ideal<=z_upper) && (z_ideal>=z_lower)
    z=z_ideal;
    theta=gH*(tauh*n*y0/(z*c));
    H0=hbar*((1/(gH-(z*h)))-1);
elseif (z_ideal>=z_upper)
    z=z_upper;
    theta=theta_vec(1,9);
    H0=H0_vec(1,9);
else 
    z=z_lower;
    theta=theta_vec(1,1);
    H0=H0_vec(1,1);
end

%calibration of phi for norms model
psi=0.1;
nstar=1;
nprev=3.5;
phi=(n-nstar)/(nprev-nstar);
Hbar=hbar;


L=1; %land stock
A=1; %production technology
N0=2.21; %initial working age population

n_p=10;

phi_vec_policy=zeros(1,n_p);
phi_vec_policy(1,1)=phi;
phi_vec_policy(1,2)=0.6;
for i=3:n_p
    phi_vec_policy(1,i)=0.37;
end


%1. only norms - with policy change
phi=(n-nstar)/(nprev-nstar);

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nn0 = u(1);
hdn0 = u(2);

Ydn0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdn0=N0+N0*nn0;
ydn0=Ydn0/Pdn0;
Xdn0=L/N0;

hdn = zeros(1,n_p);
Hdn = zeros(1,n_p);
nn_vec = zeros(1,n_p);
Ndn = zeros(1,n_p);
Pdn = zeros(1,n_p);
Ydn = zeros(1,n_p);
ydn = zeros(1,n_p);
ygrown=zeros(1,n_p-1);
pgrown=zeros(1,n_p-1);
Xdn = zeros(1,n_p);
norm=zeros(1,n_p);

hdn(1,1)=hdn0;
Hdn(1,1)=H0;
nn_vec(1,1)=nn0;
Ndn(1,1)=N0;
Ydn(1,1)=Ydn0;
ydn(1,1)=ydn0;
Pdn(1,1)=Pdn0;
Xdn(1,1)=Xdn0;
norm(1,1)=phi*nprev+(1-phi)*nstar;


for i=2:n_p
   phi=phi_vec_policy(1,i);
   Hdn(1,i)=z*(Hbar+Hdn(1,i-1))*(hdn(1,i-1));
   H_use=Hdn(1,i);
   Ndn(1,i)=Ndn(1,i-1)*nn_vec(1,i-1);
   nprev_use=nn_vec(1,i-1);
   
   u0=[nn_vec(1,i-1), hdn(1,i-1)];
   options=optimset('MaxFunEvals',100000);
   options=optimset(options,'MaxIter',100000);
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0, options);
   nn_vec(1,i) = u(1);
   hdn(1,i) = u(2);
   norm(1,i)= phi*nprev_use+(1-phi)*nstar;
   
   Ydn(1,i)=A*(((Hbar+Hdn(1,i))*Ndn(1,i))^(1-rho))*((L)^(rho));
   Pdn(1,i)=nn_vec(1,i)*Ndn(1,i)+Ndn(1,i);
   ydn(1,i)=Ydn(1,i)/Pdn(1,i);
   Xdn(1,i)=L/Ndn(1,i);
   ygrown(1,i-1)=(ydn(1,i)-ydn(1,i-1))/ydn(1,i-1);
   pgrown(1,i-1)=(Pdn(1,i)-Pdn(1,i-1))/Pdn(1,i-1);
end    

lnydn=log(ydn);
lnPdn=log(Pdn);
TFR_norm=2*nn_vec;

%2. Norms only with no policy
phi=(n-nstar)/(nprev-nstar);
psi=0.1;

u0=[3, 0.5];
u = fsolve(@(u) myfun_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev, phi, z, Hbar, H0),u0); 
nnp0 = u(1);
hdnp0 = u(2);

Ydnp0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pdnp0=N0+N0*nnp0;
ydnp0=Ydnp0/Pdnp0;
Xdnp0=L/N0;

hdnp = zeros(1,n_p);
Hdnp = zeros(1,n_p);
nnp_vec = zeros(1,n_p);
Ndnp = zeros(1,n_p);
Pdnp = zeros(1,n_p);
Ydnp = zeros(1,n_p);
ydnp = zeros(1,n_p);
Xdnp = zeros(1,n_p);
ygrownp=zeros(1,n_p-1);
pgrownp=zeros(1,n_p-1);
normnp=zeros(1, n_p);

hdnp(1,1)=hdnp0;
Hdnp(1,1)=H0;
nnp_vec(1,1)=nnp0;
Ndnp(1,1)=N0;
Ydnp(1,1)=Ydnp0;
ydnp(1,1)=ydnp0;
Pdnp(1,1)=Pdnp0;
Xdnp(1,1)=Xdnp0;
normnp(1,1)=phi*nprev+(1-phi)*nstar;


for i=2:n_p
   Hdnp(1,i)=z*(Hbar+Hdnp(1,i-1))*(hdnp(1,i-1));
   H_use=Hdnp(1,i);
   Ndnp(1,i)=Ndnp(1,i-1)*nnp_vec(1,i-1);
   nprev_use=nnp_vec(1,i-1);
   
   options=optimset('MaxFunEvals',100000);
   options=optimset(options,'MaxIter',100000);
   u0=[nnp_vec(1,i-1), hdnp(1,i-1)];
   u = fsolve(@(u) myfun1_norm290416(u,tau0, tauh, theta, alpha, psi, nstar, nprev_use, phi, z, Hbar, H_use),u0, options);
   nnp_vec(1,i) = u(1);
   hdnp(1,i) = u(2);
   normnp(1,i)=phi*nprev_use+(1-phi)*nstar;
  
   Ydnp(1,i)=A*(((Hbar+Hdnp(1,i))*Ndnp(1,i))^(1-rho))*((L)^(rho));
   Pdnp(1,i)=nnp_vec(1,i)*Ndnp(1,i)+Ndnp(1,i);
   ydnp(1,i)=Ydnp(1,i)/Pdnp(1,i);
   Xdnp(1,i)=L/Ndnp(1,i);
   
   ygrownp(1,i-1)=(ydnp(1,i)-ydnp(1,i-1))/ydnp(1,i-1);
   pgrownp(1,i-1)=(Pdnp(1,i)-Pdnp(1,i-1))/Pdnp(1,i-1);
end    

lnydnp=log(ydnp);
lnPdnp=log(Pdnp);
TFR_norm_np=2*nnp_vec;

%3. Baseline model with no norms or uncertainty
u0=0.5;
ht = fsolve(@(ht) myfun_baseline290416(ht,tau0, tauh, theta, alpha, z, Hbar, H0),u0); 
hb0 = ht;
nb0=alpha/((1+alpha)*(tau0+tauh*hb0));

Yb0=A*(((Hbar+H0)*N0)^(1-rho))*((L)^(rho));
Pb0=N0+N0*nb0;
yb0=Yb0/Pb0;
Xb0=L/N0;

%dynamic path

hb = zeros(1,n_p);
Hb = zeros(1,n_p);
nb_vec = zeros(1,n_p);
Nb = zeros(1,n_p);
Pb = zeros(1,n_p);
Yb = zeros(1,n_p);
yb = zeros(1,n_p);
Xb = zeros(1,n_p);
ygrowb=zeros(1,n_p-1);
pgrowb=zeros(1,n_p-1);

hb(1,1)=hb0;
Hb(1,1)=H0;
nb_vec(1,1)=nb0;
Nb(1,1)=N0;
Yb(1,1)=Yb0;
yb(1,1)=yb0;
Pb(1,1)=Pb0;
Xb(1,1)=Xb0;


for i=2:n_p
   Hb(1,i)=z*(Hbar+Hb(1,i-1))*(hb(1,i-1));
   H_use=Hb(1,i);
   Nb(1,i)=Nb(1,i-1)*nb_vec(1,i-1);
      
   u0=[hb(1,i-1)];
   ht = fsolve(@(ht) myfun1_baseline290416(ht,tau0, tauh, theta, alpha, z, Hbar, H_use),u0);
   hb(1,i)=ht;
   nb_vec(1,i) = alpha/((1+alpha)*(tau0+tauh*hb(1,i)));
   
   Yb(1,i)=A*(((Hbar+Hb(1,i))*Nb(1,i))^(1-rho))*((L)^(rho));
   Pb(1,i)=nb_vec(1,i)*Nb(1,i)+Nb(1,i);
   yb(1,i)=Yb(1,i)/Pb(1,i);
   Xb(1,i)=L/Nb(1,i);
   
   ygrowb(1,i-1)=(yb(1,i)-yb(1,i-1))/yb(1,i-1);
   pgrowb(1,i-1)=(Pb(1,i)-Pb(1,i-1))/Pb(1,i-1);
end    

lnyb=log(yb);
lnPb=log(Pb);
TFR_base=2*nb_vec;

TFR_data=[5.97;	3.94; 2.51];
h_data=[5; 7.846254; 10.67555];
popgrowth_data=[0.56;0.32];
ygrowth_data=[1;1.5];

subplot(1,2,1);
plot(TFR_norm,'-g','DisplayName','TFR_norm','LineWidth',2);
hold all;
plot(TFR_norm_np,'--m','DisplayName','TFR_norm_np','LineWidth',2);
hold all;
plot(TFR_base,'-.b','DisplayName','TFR_base','LineWidth',2);
hold all;
plot(TFR_data,'+','DisplayName','TFR_data', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;

title('Fertility','fontsize',14);
xlabel('t','fontsize', 14);

subplot(1,2,2);
plot(hdn,'-g','DisplayName','hdn','LineWidth',2);
hold all;
plot(hdnp,'--m','DisplayName','hdnp','LineWidth',2);
hold all;
plot(hb,'-.b','DisplayName','hb','LineWidth',2);
hold all;
plot(h_data,'+','DisplayName','hb', 'MarkerEdgeColor', 'k', 'MarkerSize', 8);
hold off;
title('Human capital investment', 'fontsize', 14);
xlabel('t', 'fontsize', 14);

ax1 = subplot(1,2,1);
ylabel(ax1,'TFR', 'fontsize',14);
ax2 = subplot(1,2,2);
ylabel(ax2,'Years of schooling','fontsize',14);


leg=legend('policy', 'no policy', 'Baseline','Orientation','horizontal');
set(leg, 'fontsize', 12);

